#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7
#Tidy_Parameters=/sort_funcs /reel

#include <array.au3>
#include <date.au3>
#include "XMLWrapperEx.au3"

; This COM Error Hanlder will be used globally (excepting inside UDF Functions)
Global $oErrorHandler = ObjEvent("AutoIt.Error", ErrFunc_CustomUserHandler_MAIN)
#forceref $oErrorHandler

; This is SetUp for the transfer UDF internal COM Error Handler to the user function
_XML_ComErrorHandler_UserFunction(ErrFunc_CustomUserHandler_XML)


;~ Example_1__XML_SelectNodes()

;~ Example_2__XML_CreateChildWAttr()
;~ If @error Then MsgBox(0, 'Example_2__XML_CreateChildWAttr(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_3__XML_ErrorParser_GetDescription()
;~ If @error Then MsgBox(0, 'Example_3__XML_ErrorParser_GetDescription(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_4__XML_RemoveAttribute()
;~ If @error Then MsgBox(0, 'Example_4__XML_RemoveAttribute(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_5__XML_ReplaceChild()
;~ If @error Then MsgBox(0, 'Example_5__XML_ReplaceChild(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_6__XML_GetChildNodes()
;~ If @error Then MsgBox(0, 'Example_6__XML_GetChildNodes(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_7__XML_GetAllAttribIndex()
;~ If @error Then MsgBox(0, 'Example_7__XML_GetAllAttribIndex(): @error:', XML_My_ErrorParser(@error, @extended))

;~ Example_8__XML_GetNodeAttributeValue()
;~ If @error Then MsgBox(0, 'Example_8__XML_GetNodeAttributeValue(): @error:', XML_My_ErrorParser(@error, @extended))

Example_9__XML_CreateFile()

;~ Example_MSDN_1__setAttributeNode()
;~ TODO: Example_MSDN_2__Atribute_Vale(); https://msdn.microsoft.com/en-us/library/ms757007(v=vs.85).aspx

#Region XMLWrapperEx__Examples.au3 - Function

Func Example_1__XML_SelectNodes()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)
	If @error Then
		MsgBox(0, '_XML_CreateDOMDocument @error:', XML_My_ErrorParser(@error))
	Else
		; now you can add EVENT Handler
		Local $oXMLDOM_EventsHandler = ObjEvent($oXmlDoc, "XML_DOM_EVENT_")
		#forceref $oXMLDOM_EventsHandler

		; Load file to $oXmlDoc
		Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
		_XML_Load($oXmlDoc, $sXmlFile)
		If @error Then
			MsgBox(0, '_XML_Load @error:', XML_My_ErrorParser(@error))
		Else

			; simple display $oXmlDoc - for checking only
			Local $sXmlAfterTidy = _XML_TIDY($oXmlDoc)
			If @error Then
				MsgBox(0, '_XML_TIDY @error:', XML_My_ErrorParser(@error))
			Else
				MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Example_1__XML_SelectNodes', $sXmlAfterTidy)
			EndIf

			; selecting nodes
			Local $oNodesColl = _XML_SelectNodes($oXmlDoc, "//price")
			If @error Then
				MsgBox(0, '_XML_SelectNodes @error:', XML_My_ErrorParser(@error))
			Else
				; change Nodes Collection to array
				Local $aNodesColl = _XML_Array_GetNodesProperties($oNodesColl)
				If @error Then
					MsgBox(0, '_XML_Array_GetNodesProperties @error:', XML_My_ErrorParser(@error))
				Else
					; display array
					_ArrayDisplay($aNodesColl, 'Example_1__XML_SelectNodes : ' & 'Length=' & $oNodesColl.length & '   XPath=' & $oNodesColl.expr)
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc   ;==>Example_1__XML_SelectNodes

Func Example_2__XML_CreateChildWAttr()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Before Example_2__XML_CreateChildWAttr()', _XML_TIDY($oXmlDoc))

	Local $aAttributeList[2][2] = [['First', '1'], ['Second', '2']]
	_XML_CreateChildWAttr($oXmlDoc, "//book", 'MyNewNode', $aAttributeList, "SomeText")

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'After Example_2__XML_CreateChildWAttr()', _XML_TIDY($oXmlDoc))

	$oXmlDoc.loadXML(_XML_TIDY($oXmlDoc))

	; View in default System Viewer
	_XML_Misc_Viewer($oXmlDoc)

EndFunc   ;==>Example_2__XML_CreateChildWAttr

Func Example_3__XML_ErrorParser_GetDescription()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)
	If @error = $XML_ERR_XPATH Then
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Test 1: ' & @error & ' ' & @extended, XML_My_ErrorParser(@error, @extended))
	EndIf

	; now we fires COM Error
	; selecting nodes with incorrect XPath expression
	Local $oNodesColl = _XML_SelectNodes($oXmlDoc, "/1/price")
	#forceref $oNodesColl
	If @error = $XML_ERR_XPATH Then
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Test 2: ' & @error & ' ' & @extended, XML_My_ErrorParser(@error, @extended))
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Test 3: _XML_ErrorParser_GetDescription', _XML_ErrorParser_GetDescription($oXmlDoc))
	EndIf

	; now we try fires $oXmlDoc.parseError.errorCode - wrong XML file
	; again create a new clean $oXmlDoc object
	$oXmlDoc = _XML_CreateDOMDocument()

	; Load file to $oXmlDoc
	$sXmlFile = @ScriptFullPath
	_XML_Load($oXmlDoc, $sXmlFile)
	If @error = $XML_ERR_PARSE Then
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Test 2: ' & @error & ' ' & @extended, XML_My_ErrorParser(@error, @extended))
		MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Test 3: _XML_ErrorParser_GetDescription', _XML_ErrorParser_GetDescription($oXmlDoc))
	EndIf

EndFunc   ;==>Example_3__XML_ErrorParser_GetDescription

Func Example_4__XML_RemoveAttribute()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	Local $aAttributeList[2][2] = [['First', '1'], ['Second', '2']]
	_XML_CreateChildWAttr($oXmlDoc, "//book", 'MyNewNode', $aAttributeList, "SomeText")

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'After Example_2__XML_CreateChildWAttr()', _XML_TIDY($oXmlDoc))

	_XML_RemoveAttribute($oXmlDoc, "//MyNewNode[1]", 'Second')

	; TIDY xml and save result back to object
	$oXmlDoc.loadXML(_XML_TIDY($oXmlDoc))

	; View in default System Viewer
	_XML_Misc_Viewer($oXmlDoc)

EndFunc   ;==>Example_4__XML_RemoveAttribute

Func Example_5__XML_ReplaceChild()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	_XML_ReplaceChild($oXmlDoc, '//price', 'TextBook')

	; TIDY xml and save result back to object
	$oXmlDoc.loadXML(_XML_TIDY($oXmlDoc))

	; View in default System Viewer
	_XML_Misc_Viewer($oXmlDoc)

EndFunc   ;==>Example_5__XML_ReplaceChild

Func Example_6__XML_GetChildNodes()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Example_6__XML_GetChildNodes', _XML_TIDY($oXmlDoc))

	; selecting nodes
	Local $oNodesColl = _XML_GetChildNodes($oXmlDoc, "//book")

	; change Nodes Collection to array
	Local $aNodesColl = _XML_Array_GetNodesProperties($oNodesColl)
	_ArrayDisplay($aNodesColl, 'Example_6__XML_GetChildNodes: ' & 'Length=' & $oNodesColl.length & '   XPath=' & $oNodesColl.expr)

EndFunc   ;==>Example_6__XML_GetChildNodes

Func Example_7__XML_GetAllAttribIndex()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	Local $aAttributeList[2][2] = [['First', '1'], ['Second', '2']]
	_XML_CreateChildWAttr($oXmlDoc, "//book", 'MyNewNode', $aAttributeList, "SomeText")

	_XML_RemoveAttribute($oXmlDoc, "//MyNewNode[1]", 'Second')

	; TIDY xml and save result back to object
	$oXmlDoc.loadXML(_XML_TIDY($oXmlDoc))

	; View in default System Viewer
	_XML_Misc_Viewer($oXmlDoc)

	Local $oAttriubtes = _XML_GetAllAttribIndex($oXmlDoc, '//MyNewNode', 0)
	Local $aAttributesList = _XML_Array_GetAttributesProperties($oAttriubtes)

	_ArrayDisplay($aAttributesList, '$aAttributesList')

EndFunc   ;==>Example_7__XML_GetAllAttribIndex

Func Example_8__XML_GetNodeAttributeValue()
	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	Local $aAttributeList[2][2] = [['First', '1a'], ['Second', '2b']]
	_XML_CreateChildWAttr($oXmlDoc, "//book", 'MyNewNode', $aAttributeList, "SomeText")
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	Local $oAttriubtes = _XML_GetAllAttribIndex($oXmlDoc, '//MyNewNode', 0)
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	Local $aAttributesList = _XML_Array_GetAttributesProperties($oAttriubtes)
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	Local $oNode_Selected = _XML_SelectSingleNode($oXmlDoc, '//MyNewNode[1]')
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	Local $sAttribute_Value = _XML_GetNodeAttributeValue($oNode_Selected, 'First')
	If @error Then Return SetError(@error, @extended, $XML_RET_FAILURE)

	_ArrayDisplay($aAttributesList, '$sAttribute_Value = ' & $sAttribute_Value)

EndFunc   ;==>Example_8__XML_GetNodeAttributeValue

Func Example_9__XML_CreateFile()
	Local $oXMLDoc = _XML_CreateFile(@ScriptDir & "\settings.xml", "SETTINGS", True)
	#forceref $oXMLDoc

EndFunc   ;==>Example_8__XML_GetNodeAttributeValue

Func Example_MSDN_1__setAttributeNode()

	; first you must create $oXmlDoc object
	Local $oXmlDoc = _XML_CreateDOMDocument(Default)

	; Load file to $oXmlDoc
	Local $sXmlFile = @ScriptDir & "\XML_Example_XML_Files\MSDN\books.xml"
	_XML_Load($oXmlDoc, $sXmlFile)

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Example_MSDN_1__setAttributeNode', _XML_TIDY($oXmlDoc))

	;MSDN; https://msdn.microsoft.com/en-us/library/ms762235(v=vs.85).aspx

	;MSDN; nodePublishDate = xmlDoc.createAttribute("PublishDate");
	Local $oNodePublishDate = $oXmlDoc.createAttribute("PublishDate");

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Temp', _XML_TIDY($oXmlDoc)) ; Hmmm... Nothing happend

	;MSDN; nodePublishDate.value = String(Date());
	$oNodePublishDate.value = String(_Now());

	;MSDN; nodeBook = xmlDoc.selectSingleNode("//book");
	Local $oNodeBook = $oXmlDoc.selectSingleNode("//book");

	;MSDN; nodeBook.setAttributeNode(nodePublishDate);
	$oNodeBook.setAttributeNode($oNodePublishDate);

	;MSDN; WScript.Echo(nodeBook.getAttribute("PublishDate"));
	ConsoleWrite($oNodeBook.getAttribute("PublishDate") & @CRLF)

	; simple display $oXmlDoc - for checking only
	MsgBox($MB_SYSTEMMODAL + $MB_ICONINFORMATION, 'Result', _XML_TIDY($oXmlDoc))

	; this following part is not related to MSDN but is usefull to show how _XML_Array_GetNodesProperties display attributes
	Local $oNodesColl = _XML_SelectNodes($oXmlDoc, "//book")

	; change Nodes Collection to array
	Local $aNodesColl = _XML_Array_GetNodesProperties($oNodesColl)
	_ArrayDisplay($aNodesColl, 'Example_1__XML_SelectNodes : ' & $oNodesColl.expr)

EndFunc   ;==>Example_MSDN_1__setAttributeNode
#EndRegion XMLWrapperEx__Examples.au3 - Function

#Region XMLWrapperEx__Examples.au3 - XML DOM Error/Event Handling

Func ErrFunc_CustomUserHandler_MAIN($oError)

	ConsoleWrite(@ScriptName & " (" & $oError.scriptline & ") : MainScript ==> COM Error intercepted !" & @CRLF & _
			@TAB & "err.number is: " & @TAB & @TAB & "0x" & Hex($oError.number) & @CRLF & _
			@TAB & "err.windescription:" & @TAB & $oError.windescription & @CRLF & _
			@TAB & "err.description is: " & @TAB & $oError.description & @CRLF & _
			@TAB & "err.source is: " & @TAB & @TAB & $oError.source & @CRLF & _
			@TAB & "err.helpfile is: " & @TAB & $oError.helpfile & @CRLF & _
			@TAB & "err.helpcontext is: " & @TAB & $oError.helpcontext & @CRLF & _
			@TAB & "err.lastdllerror is: " & @TAB & $oError.lastdllerror & @CRLF & _
			@TAB & "err.scriptline is: " & @TAB & $oError.scriptline & @CRLF & _
			@TAB & "err.retcode is: " & @TAB & "0x" & Hex($oError.retcode) & @CRLF & @CRLF)
EndFunc   ;==>ErrFunc_CustomUserHandler_MAIN

Func ErrFunc_CustomUserHandler_XML($oError)

	; here is declared another path to UDF au3 file
	; thanks to this with using _XML_ComErrorHandler_UserFunction(ErrFunc_CustomUserHandler_XML)
	;  you get errors which after pressing F4 in SciTE4AutoIt you goes directly to the specified UDF Error Line
	ConsoleWrite(@ScriptDir & '\XMLWrapperEx.au3' & " (" & $oError.scriptline & ") : UDF ==> COM Error intercepted ! " & @CRLF & _
			@TAB & "err.number is: " & @TAB & @TAB & "0x" & Hex($oError.number) & @CRLF & _
			@TAB & "err.windescription:" & @TAB & $oError.windescription & @CRLF & _
			@TAB & "err.description is: " & @TAB & $oError.description & @CRLF & _
			@TAB & "err.source is: " & @TAB & @TAB & $oError.source & @CRLF & _
			@TAB & "err.helpfile is: " & @TAB & $oError.helpfile & @CRLF & _
			@TAB & "err.helpcontext is: " & @TAB & $oError.helpcontext & @CRLF & _
			@TAB & "err.lastdllerror is: " & @TAB & $oError.lastdllerror & @CRLF & _
			@TAB & "err.scriptline is: " & @TAB & $oError.scriptline & @CRLF & _
			@TAB & "err.retcode is: " & @TAB & "0x" & Hex($oError.retcode) & @CRLF & @CRLF)
EndFunc   ;==>ErrFunc_CustomUserHandler_XML

Func XML_DOM_EVENT_ondataavailable()
		#CS
		ondataavailable Event
		https://msdn.microsoft.com/en-us/library/ms754530(v=vs.85).aspx
	#CE
	Local $oEventObj = @COM_EventObj
	ConsoleWrite('@COM_EventObj = ' & ObjName($oEventObj, 3) & @CRLF)

	Local $sMessage = 'XML_DOM_EVENT_ fired "ondataavailable"' & @CRLF
	ConsoleWrite($sMessage)
EndFunc   ;==>XML_DOM_EVENT_ondataavailable

Func XML_DOM_EVENT_onreadystatechange()
	#CS
		onreadystatechange Event
		https://msdn.microsoft.com/en-us/library/ms759186(v=vs.85).aspx
	#CE
	Local $oEventObj = @COM_EventObj
	ConsoleWrite('@COM_EventObj = ' & ObjName($oEventObj, 3) & @CRLF)

	Local $sMessage = 'XML_DOM_EVENT_ fired "onreadystatechange" : ReadyState = ' & $oEventObj.ReadyState & @CRLF
	ConsoleWrite($sMessage)

EndFunc   ;==>XML_DOM_EVENT_onreadystatechange

Func XML_DOM_EVENT_ontransformnode($oNodeCode_XSL, $oNodeData_XML, $bBool)
	#forceref $oNodeCode_XSL, $oNodeData_XML, $bBool
	#CS
		ontransformnode Event
		https://msdn.microsoft.com/en-us/library/ms767521(v=vs.85).aspx
	#CE
	Local $oEventObj = @COM_EventObj
	ConsoleWrite('@COM_EventObj = ' & ObjName($oEventObj, 3) & @CRLF)

	Local $sMessage = 'XML_DOM_EVENT_ fired "ontransformnode"' & @CRLF
	ConsoleWrite($sMessage)

EndFunc   ;==>XML_DOM_EVENT_ontransformnode

; #FUNCTION# ====================================================================================================================
; Name ..........: XML_My_ErrorParser
; Description ...: Changing $XML_ERR_ ... to human readable description
; Syntax ........: XML_My_ErrorParser($iXMLWrapper_Error, $iXMLWrapper_Extended)
; Parameters ....: $iXMLWrapper_Error	- an integer value.
;                  $iXMLWrapper_Extended           - an integer value.
; Return values .: description as string
; Author ........: mLipok
; Modified ......:
; Remarks .......: This function is only example of how user can parse @error and @extended to human readable description
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func XML_My_ErrorParser($iXMLWrapper_Error, $iXMLWrapper_Extended = 0)
	Local $sErrorInfo = ''
	Switch $iXMLWrapper_Error
		Case $XML_ERR_OK
			$sErrorInfo = 'All is ok.'
		Case $XML_ERR_GENERAL
			$sErrorInfo = 'The error which is not specifically defined.'
		Case $XML_ERR_ISNOTOBJECT
			$sErrorInfo = 'No object passed to function'
		Case $XML_ERR_ISNOTVALIDDOMDOC
			$sErrorInfo = 'Invalid object passed to function'
		Case $XML_ERR_PARSE
			$sErrorInfo = 'Error: with Parsing objects, .parseError.errorCode=' & $iXMLWrapper_Extended & ' Use _XML_ErrorParser_GetDescription() for get details.'
		Case $XML_ERR_LOAD
			$sErrorInfo = 'Error opening specified file.'
		Case $XML_ERR_SAVE
			$sErrorInfo = 'Error saving file.'
		Case $XML_ERR_SAVEFILERO
			$sErrorInfo = 'Destination file is Read Only.'
		Case $XML_ERR_XPATH
			$sErrorInfo = 'XPath syntax error - check also COM Error Handler.'
		Case $XML_ERR_DOMVERSION
			$sErrorInfo = 'DOM Version: ' & 'MSXML Version ' & $iXMLWrapper_Extended & ' or greater required for this function'
		Case $XML_ERR_PARAMETER
			$sErrorInfo = 'Wrong parameter passed to function.'
		Case $XML_ERR_ARRAY
			$sErrorInfo = 'Wrong array parameter passed to function. Check array dimension and conent.'
		Case $XML_ERR_NODECREATE
			$sErrorInfo = 'Can not create Node - check also extended for node type'
		Case $XML_ERR_NODEAPPEND
			$sErrorInfo = 'Can not append Node - check also extended for node type'
		Case $XML_ERR_EMPTYCOLLECTION
			$sErrorInfo = 'Collections of objects was empty'
		Case $XML_ERR_NONODESMATCH
			$sErrorInfo = 'No nodes match the XPath expression'
		Case $XML_ERR_PARSE_XSL
			$sErrorInfo = 'Error with Parsing XSL objects .parseError.errorCode=' & $iXMLWrapper_Extended & ' Use _XML_ErrorParser_GetDescription() for get details.'
		Case $XML_ERR_NOATTRMATCH
			$sErrorInfo = 'There is no such attribute in selected node.'
		Case $XML_ERR_NOCHILDMATCH
			$sErrorInfo = 'There is no Child in nodes matched by XPath expression.'
		Case $XML_ERR_OBJCREATE
			$sErrorInfo = 'Object can not be created.'
		Case $XML_ERR_ISNOTVALIDATTRIB
			$sErrorInfo = 'Invalid object passed to function.'
		Case $XML_ERR_ISNOTVALIDNODES
			$sErrorInfo = 'Invalid object passed to function.'
		Case Else
			$sErrorInfo = 'NO ERROR DESCRIPTION FOR:' & $iXMLWrapper_Error
	EndSwitch

	Local $sExtendedInfo = ''
	Switch $iXMLWrapper_Extended
		Case $XML_EXT_DEFAULT
			$sExtendedInfo = 'Default - Do not return any additional information'
		Case $XML_EXT_GENERAL
			$sExtendedInfo = 'The extended which is not specifically defined.'
		Case $XML_EXT_XMLDOM
			$sExtendedInfo = '"Microsoft.XMLDOM" related Error'
		Case $XML_EXT_DOMDOCUMENT
			$sExtendedInfo = '"Msxml2.DOMDocument" related Error'
		Case $XML_EXT_XSLTEMPLATE
			$sExtendedInfo = '"Msxml2.XSLTemplate" related Error'
		Case $XML_EXT_SAXXMLREADER
			$sExtendedInfo = '"MSXML2.SAXXMLReader" related Error'
		Case $XML_EXT_MXXMLWRITER
			$sExtendedInfo = '"MSXML2.MXXMLWriter" related Error'
		Case $XML_EXT_FREETHREADEDDOMDOCUMENT
			$sExtendedInfo = '"Msxml2.FreeThreadedDOMDocument" related Error'
		Case $XML_EXT_XMLSCHEMACACHE
			$sExtendedInfo = '"Msxml2.XMLSchemaCache." related Error'
		Case $XML_EXT_STREAM
			$sExtendedInfo = '"ADODB.STREAM" related Error'
		Case $XML_EXT_ENCODING
			$sExtendedInfo = 'Encoding related Error'
		Case Else
			$sExtendedInfo = 'Unknow EXTENDED info.'
	EndSwitch

	; return back @error and @extended for further debuging
	Return SetError($iXMLWrapper_Error, $iXMLWrapper_Extended, _
			'@error description:' & @CRLF & _
			$sErrorInfo & @CRLF & _
			@CRLF & _
			'@error description:' & @CRLF & _
			$sExtendedInfo & @CRLF & _
			'')

EndFunc   ;==>XML_My_ErrorParser
#EndRegion XMLWrapperEx__Examples.au3 - XML DOM Error/Event Handling

#Region XMLWrapperEx__Examples.au3 - Help, Documentation, Manuals
#CS
	How Do I Use XML?
	https://msdn.microsoft.com/en-us/library/ms759092(v=vs.85).aspx

	A Beginner's Guide to the XML DOM
	https://msdn.microsoft.com/en-us/library/aa468547.aspx

	DOM Reference
	https://msdn.microsoft.com/en-us/library/ms764730(v=vs.85).aspx

	XML DOM Properties
	https://msdn.microsoft.com/en-us/library/ms763798(v=vs.85).aspx

	XML DOM Methods
	https://msdn.microsoft.com/en-us/library/ms757828(v=vs.85).aspx

	XML Glossary
	https://msdn.microsoft.com/en-us/library/ms256452(v=vs.85).aspx

	MSXML API History
	https://msdn.microsoft.com/en-us/library/ms762314(v=vs.85).aspx

	XML Standards Reference
	https://msdn.microsoft.com/en-us/library/ms256177(v=vs.85).aspx

	XSLT Reference
	https://msdn.microsoft.com/en-us/library/ms256069(v=vs.85).aspx

	XPath Reference
	https://msdn.microsoft.com/en-us/library/ms256115(v=vs.85).aspx

	XPath Syntax
	https://msdn.microsoft.com/en-us/library/ms256471(v=vs.85).aspx

	XPath Examples
	https://msdn.microsoft.com/en-us/library/ms256086(v=vs.110).aspx

	XML DOM Objects/Interfaces
	https://msdn.microsoft.com/en-us/library/ms760218(v=vs.85).aspx

	Location Path Examples
	https://msdn.microsoft.com/en-us/library/ms256236(v=vs.110).aspx

	Microsoft XML DOM output has no CR/LF
	http://www.experts-exchange.com/Web_Development/Web_Languages-Standards/Q_20135543.html

	Formatting of XML file
	http://www.visualbasicscript.com/Formatting-of-XML-file-m77414.aspx

	Stream Object (ADO)
	https://msdn.microsoft.com/en-us/library/windows/desktop/ms675032(v=vs.85).aspx

	TODO:
	IXMLDOMAttribute Members  ($oAttribute)
	https://msdn.microsoft.com/en-us/library/ms767677(v=vs.85).aspx

	XML Editing: A WYSIWYG XML Document Editor
	https://msdn.microsoft.com/en-us/library/ms977865.aspx

	Understanding XML Namespaces
	https://msdn.microsoft.com/en-us/library/aa468565.aspx

	Understanding XML
	https://msdn.microsoft.com/en-us/library/aa468558.aspx

#CE
#CS ON LINE XPath Tools
	http://www.xpathtester.com/xpath
	http://codebeautify.org/Xpath-Tester
	http://xpath.online-toolz.com/tools/xpath-editor.php
	http://www.whitebeam.org/library/guide/TechNotes/xpathtestbed.rhtm
	http://www.qutoric.com/xslt/analyser/xpathtool.html
	https://addons.mozilla.org/en-US/firefox/addon/xpather/
	http://www.xmlme.com/XpathTool.aspx
#CE
#CS OFF LINE XPath Tools
	http://qutoric.com/xmlquire/
	https://xpathvisualizer.codeplex.com/
#CE
#EndRegion XMLWrapperEx__Examples.au3 - Help, Documentation, Manuals



#Region TEST
Func XML_ObjName_FlagsValue(ByRef $oObj)
    Local $sInfo = ''

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,1) {The name of the Object} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_NAME) & @CRLF

    ; HELPFILE REMARKS: Not all Objects support flags 2 to 7. Always test for @error in these cases.
    $sInfo &= '+>' & @TAB & 'ObjName($oObj,2) {Description string of the Object} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_STRING)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,3) {The ProgID of the Object} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_PROGID)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,4) {The file that is associated with the object in the Registry} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_FILE)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,5) {Module name in which the object runs (WIN XP And above). Marshaller for non-inproc objects.} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_MODULE)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,6) {CLSID of the object''s coclass} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_CLSID)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    $sInfo &= '+>' & @TAB & 'ObjName($oObj,7) {IID of the object''s interface} =' & @CRLF & @TAB & ObjName($oObj, $OBJ_IID)
    If @error Then $sInfo &= '@error = ' & @error
    $sInfo &= @CRLF & @CRLF

    MsgBox($MB_SYSTEMMODAL, "ObjName:", $sInfo)
EndFunc   ;==>ObjName_FlagsValue

#EndRegion